//
// Copyright 2003 Perforce Software.  All rights reserved.
//
// This file is part of Perforce - the FAST SCM System.
//
// p4wJsHier:
//   Builds a Strbuf containing the requested javascript data.
//   This class is used for generating hierarchical drop-down
//   menus.

#ifndef p4wJsHier_H
#define p4wJsHier_H

#define crlf	"\n"

class p4wJsHier : public StrBuf {

public:

	p4wJsHier() : StrBuf() {};
	virtual	~p4wJsHier() {};
	

	//
	// Methods to begin and end javascript section are
	// provided for convenience
	
	p4wJsHier & beginJs( const char *version );
	p4wJsHier & endJs();
	
	//
	// javascript API to create hierarchical menus
			
	p4wJsHier & menuAPI();
	
	p4wJsHier & newMenu( const char *label, int menuHeight, int menuWidth,
		const char *font, int fontSize, const char * fontColor,
		const char *fontHiColor, const char *itemBgColor,
		const char *hiBgColor, const char *halgn, const char *valgn,
		int pad, int space, int to, int sx, int sy, int srel,
		int opaque, int vert, int indent );
		
	p4wJsHier & menuAtts( const char *label, const char *fontWeight,
		int hideMouseOut, int menuBorder,
		const char *liteBgColor, const char *borderBgColor,
		const char *bgColor );
		
	p4wJsHier & addMenuItem( const char *name, const char *tag, 
		const char *action );
		
	p4wJsHier & writeMenus( const char *name );
	

private:
	void menuAPI1();
	void menuAPI2();
	void menuAPI3();
	void menuAPI4();
	void menuAPI5();
};

#endif // p4wJs_H
